RelabeledAlignment (BioJava-1.5-beta API)
Keywords: org.biojava.bio.symbol.RelabeledAlignment class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.biojava.bio.symbol
Class RelabeledAlignment

    java.lang.Object
      org.biojava.utils.Unchangeable
          org.biojava.bio.symbol.RelabeledAlignment

All Implemented Interfaces:
  Alignment, SymbolList, Changeable

    public class RelabeledAlignment

extends Unchangeable
implements Alignment

An alignment that relabels another alignment.

Author:
  Matthew Pocock, Nimesh Singh

Nested Class Summary

Nested classes/interfaces inherited from interface org.biojava.bio.symbol.Alignment
`Alignment.SymbolListIterator`

Field Summary

Fields inherited from interface org.biojava.bio.symbol.Alignment
`CONTENT`

Fields inherited from interface org.biojava.bio.symbol.SymbolList
`EDIT, EMPTY_LIST`

Constructor Summary
`RelabeledAlignment(Alignment delegate)`

Method Summary
`void` | `edit(Edit edit)` Apply an edit to the SymbolList as specified by the edit object.
`Alphabet` | `getAlphabet()` The alphabet that this SymbolList is over.
`List` | `getLabels()` The list of SymbolLists in the alignment.
`Iterator` | `iterator()` An Iterator over all Symbols in this SymbolList.
`int` | `length()` The number of symbols in this SymbolList.
`protected Object` | `map(Object label)`
`protected Set` | `map(Set labels)`
`String` | `seqString()` Stringify this symbol list.
`Alignment` | `subAlignment(Set labels, Location loc)` Make a view onto this alignment.
`SymbolList` | `subList(int min, int max)` Return a new SymbolList for the symbols start to end inclusive.
`String` | `subStr(int min, int max)` Return a region of this symbol list as a String.
`Symbol` | `symbolAt(int pos)` Return the symbol at index, counting from 1.
`Symbol` | `symbolAt(Object label, int column)` Retrieve a symbol by label and column.
`SymbolList` | `symbolListForLabel(Object label)` Retrieve a single row of the alignment by label.
`Iterator` | `symbolListIterator()` Creates an Iterator over the SymbolLists in the alignment.
`List` | `toList()` Returns a List of symbols.

Methods inherited from class org.biojava.utils.Unchangeable
`addChangeListener, addChangeListener, addForwarder, getForwarders, getListeners, isUnchanging, removeChangeListener, removeChangeListener, removeForwarder`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.biojava.utils.Changeable
`addChangeListener, addChangeListener, isUnchanging, removeChangeListener, removeChangeListener`

Constructor Detail

### RelabeledAlignment

    public RelabeledAlignment(Alignment delegate)

Method Detail

### getLabels

    public List getLabels()

  Description copied from interface: `Alignment`

  The list of SymbolLists in the alignment.

  The index in the list is the same as the index in the alignment. Each SymbolList object will only be in the alignment once. However, a single underlying SymbolList may have more than one view within an alignment, each represented by a different GappedSymbolList.

  Specified by:
    `getLabels` in interface `Alignment`
  Returns:
    the List of all SymbolLists in the alignment

### symbolAt

    public Symbol symbolAt(Object label,
                           int column)
                    throws NoSuchElementException

  Description copied from interface: `Alignment`
  Retrieve a symbol by label and column.

  Specified by:
    `symbolAt` in interface `Alignment`
  Parameters:
    `label` - the SymbolList to retrieve from
    `column` - the index of the column to retrieve
  Returns:
    the symbol in the symbol list associated with the label at the given column
  Throws:
    `NoSuchElementException` - if there is no row for 'label'

### symbolListForLabel

    public SymbolList symbolListForLabel(Object label)
                                  throws NoSuchElementException

  Description copied from interface: `Alignment`
  Retrieve a single row of the alignment by label.

  Specified by:
    `symbolListForLabel` in interface `Alignment`
  Parameters:
    `label` - the object from which to retrieve the symbol list
  Returns:
    a SymbolList that contains each token in a row of the alignment
  Throws:
    `NoSuchElementException` - if there is no row for 'label'

### subAlignment

    public Alignment subAlignment(Set labels,
                                  Location loc)
                           throws NoSuchElementException

  Description copied from interface: `Alignment`

  Make a view onto this alignment.

  If labels is null, then each label will be kept. Otherwise, only those in labels will be kept. If loc is null, then the entire length of the alignment will be kept. If loc is not null, then only the columns within the location will be kept.

  Specified by:
    `subAlignment` in interface `Alignment`
  Parameters:
    `labels` - the Set of sequences to include by label
    `loc` - the Location to include
  Returns:
    a sub Alignment
  Throws:
    `NoSuchElementException` - if labels contains any item that is not a label

### seqString

    public String seqString()

  Description copied from interface: `SymbolList`
  Stringify this symbol list.

  It is expected that this will use the symbol's token to render each symbol. It should be parsable back into a SymbolList using the default token parser for this alphabet.

  Specified by:
    `seqString` in interface `SymbolList`
  Returns:
    a string representation of the symbol list

### subStr

    public String subStr(int min,
                         int max)

  Description copied from interface: `SymbolList`
  Return a region of this symbol list as a String.

  This should use the same rules as seqString.

  Specified by:
    `subStr` in interface `SymbolList`
  Parameters:
    `min` - the first symbol to include
    `max` - the last symbol to include
  Returns:
    the string representation

### getAlphabet

    public Alphabet getAlphabet()

  Description copied from interface: `SymbolList`
  The alphabet that this SymbolList is over.

  Every symbol within this SymbolList is a member of this alphabet. `alphabet.contains(symbol) == true` for each symbol that is within this sequence.

  Specified by:
    `getAlphabet` in interface `SymbolList`
  Returns:
    the alphabet

### iterator

    public Iterator iterator()

  Description copied from interface: `SymbolList`
  An Iterator over all Symbols in this SymbolList.

  This is an ordered iterator over the Symbols. It cannot be used to edit the underlying symbols.

  Specified by:
    `iterator` in interface `SymbolList`
  Returns:
    an iterator

### length

    public int length()

  Description copied from interface: `SymbolList`
  The number of symbols in this SymbolList.

  Specified by:
    `length` in interface `SymbolList`
  Returns:
    the length

### toList

    public List toList()

  Description copied from interface: `SymbolList`
  Returns a List of symbols.

  This is an immutable list of symbols. Do not edit it.

  Specified by:
    `toList` in interface `SymbolList`
  Returns:
    a List of Symbols

### subList

    public SymbolList subList(int min,
                              int max)

  Description copied from interface: `SymbolList`
  Return a new SymbolList for the symbols start to end inclusive.

  The resulting SymbolList will count from 1 to (end-start + 1) inclusive, and refer to the symbols start to end of the original sequence.

  Specified by:
    `subList` in interface `SymbolList`
  Parameters:
    `min` - the first symbol of the new SymbolList
    `max` - the last symbol (inclusive) of the new SymbolList

### symbolAt

    public Symbol symbolAt(int pos)

  Description copied from interface: `SymbolList`
  Return the symbol at index, counting from 1.

  Specified by:
    `symbolAt` in interface `SymbolList`
  Parameters:
    `pos` - the offset into this SymbolList
  Returns:
    the Symbol at that index

### edit

    public void edit(Edit edit)
              throws IllegalAlphabetException,
                     ChangeVetoException

  Description copied from interface: `SymbolList`
  Apply an edit to the SymbolList as specified by the edit object.

  ## Description

  All edits can be broken down into a series of operations that change contiguous blocks of the sequence. This represent a one of those operations.

  When applied, this Edit will replace 'length' number of symbols starting a position 'pos' by the SymbolList 'replacement'. This allow to do insertions (length=0), deletions (replacement=SymbolList.EMPTY_LIST) and replacements (length>=1 and replacement.length()>=1).

  The pos and pos+length should always be valid positions on the SymbolList to:

  - be edited (between 0 and symL.length()+1).
  - To append to a sequence, pos=symL.length()+1, pos=0.
  - To insert something at the beginning of the sequence, set pos=1 and length=0.

  ## Examples

  `

       SymbolList seq = DNATools.createDNA("atcaaaaacgctagc");
       System.out.println(seq.seqString());

       // delete 5 bases from position 4
       Edit ed = new Edit(4, 5, SymbolList.EMPTY_LIST);
       seq.edit(ed);
       System.out.println(seq.seqString());

       // delete one base from the start
       ed = new Edit(1, 1, SymbolList.EMPTY_LIST);
       seq.edit(ed);

       // delete one base from the end
       ed = new Edit(seq.length(), 1, SymbolList.EMPTY_LIST);
       seq.edit(ed);
       System.out.println(seq.seqString());

       // overwrite 2 bases from position 3 with "tt"
       ed = new Edit(3, 2, DNATools.createDNA("tt"));
       seq.edit(ed);
       System.out.println(seq.seqString());

       // add 6 bases to the start
       ed = new Edit(1, 0, DNATools.createDNA("aattgg");
       seq.edit(ed);
       System.out.println(seq.seqString());

       // add 4 bases to the end
       ed = new Edit(seq.length() + 1, 0, DNATools.createDNA("tttt"));
       seq.edit(ed);
       System.out.println(seq.seqString());

       // full edit
       ed = new Edit(3, 2, DNATools.createDNA("aatagaa");
       seq.edit(ed);
       System.out.println(seq.seqString());

  `

  Specified by:
    `edit` in interface `SymbolList`
  Parameters:
    `edit` - the Edit to perform
  Throws:
    `IllegalAlphabetException` - if the SymbolList to insert has an incompatible alphabet
    `ChangeVetoException` - if either the SymboList does not support the edit, or if the change was vetoed

### symbolListIterator

    public Iterator symbolListIterator()

  Description copied from interface: `Alignment`
  Creates an Iterator over the SymbolLists in the alignment. This should be similar to iterating over the labels and then fetching each SymbolList, but the order is not guaranteed to be the same.

  Specified by:
    `symbolListIterator` in interface `Alignment`
  Returns:
    an Iterator

### map

    protected Set map(Set labels)

### map

    protected Object map(Object label)

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD